zoukankan      html  css  js  c++  java
  • 【LeetCode】174. Dungeon Game

    Dungeon Game

    The demons had captured the princess (P) and imprisoned her in the bottom-right corner of a dungeon. The dungeon consists of M x N rooms laid out in a 2D grid. Our valiant knight (K) was initially positioned in the top-left room and must fight his way through the dungeon to rescue the princess.

    The knight has an initial health point represented by a positive integer. If at any point his health point drops to 0 or below, he dies immediately.

    Some of the rooms are guarded by demons, so the knight loses health (negative integers) upon entering these rooms; other rooms are either empty (0's) or contain magic orbs that increase the knight's health (positive integers).

    In order to reach the princess as quickly as possible, the knight decides to move only rightward or downward in each step.

    Write a function to determine the knight's minimum initial health so that he is able to rescue the princess.

    For example, given the dungeon below, the initial health of the knight must be at least 7 if he follows the optimal path RIGHT-> RIGHT -> DOWN -> DOWN.

    -2 (K) -3 3
    -5 -10 1
    10 30 -5 (P)

    Notes:

    • The knight's health has no upper bound.
    • Any room can contain threats or power-ups, even the first room the knight enters and the bottom-right room where the princess is imprisoned.

    Credits:
    Special thanks to @stellari for adding this problem and creating all test cases.

    由于最终目标是骑士到达公主位置,因此在右下角必须满足HP剩余1.

    从右下角位置开始倒推,每个位置需要同时满足两个条件:(1)该位置HP为1(保证不死),(2)该位置的HP足够到达公主(使用动态规划)

    class Solution {
    public:
        int calculateMinimumHP(vector<vector<int>>& dungeon) {
            if(dungeon.empty() || dungeon[0].empty())
                return 1;
            int m = dungeon.size();
            int n = dungeon[0].size();
            vector<vector<int> > minHP(m, vector<int>(n,0));
            for(int i = m-1; i >= 0; i --)
            {
                for(int j = n-1; j >= 0; j --)
                {
                    if(i == m-1 && j == n-1)
                        minHP[i][j] = max(1, 1-dungeon[i][j]);
                    else if(i == m-1)
                        minHP[i][j] = max(1, minHP[i][j+1]-dungeon[i][j]);
                    else if(j == n-1)
                        minHP[i][j] = max(1, minHP[i+1][j]-dungeon[i][j]);
                    else 
                        minHP[i][j] = max(1, min(minHP[i+1][j]-dungeon[i][j], minHP[i][j+1]-dungeon[i][j]));
                }
            }
            return minHP[0][0];
        }
    };

  • 相关阅读:
    《那些年啊,那些事——一个程序员的奋斗史》——48
    《那些年啊,那些事——一个程序员的奋斗史》——49
    《那些年啊,那些事——一个程序员的奋斗史》——47
    《那些年啊,那些事——一个程序员的奋斗史》——46
    《那些年啊,那些事——一个程序员的奋斗史》——46
    如何面对单调重复的任务
    几则关于glibc的locale的笔记
    欢迎大家加入Linux Mobile Research圈子
    Idle函数的三大用途
    几则gdb使用技巧
  • 原文地址:https://www.cnblogs.com/ganganloveu/p/4231757.html
Copyright © 2011-2022 走看看